#define AMD_TRESSFX_MAX_HAIR_GROUP_RENDER 16
#define AMD_TRESSFX_MAX_NUM_BONES 512
#define TRESSFX_VULKAN 1
//---------------------------------------------------------------------------------------
// Shader code related to shadowing for TressFX
//-------------------------------------------------------------------------------------
//
// Copyright (c) 2019 Advanced Micro Devices, Inc. All rights reserved.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//

#include "TressFXRendering.hlsl"
#include "TressFXStrands.hlsl"

[[vk::binding(0, 2)]] cbuffer shadowViewConstants : register(b0, space2)
{
    float4x4    g_mVP;
    float4      g_vEye;
    float4      g_vViewport;
    float4x4    cInvViewProjMatrix;
};


// Hair input structure to Pixel shaders
struct PS_INPUT_HAIR
{
    float4 Position    : SV_POSITION;
};

//////////////////////////////////////////////////////////////
// Hair Render VS (for depth alpha and color fill passes)
PS_INPUT_HAIR HairShadowVS(uint vertexId : SV_VertexID)
{
    TressFXVertex tressfxVert = GetExpandedTressFXShadowVert(vertexId, g_vEye, g_vViewport.zw, g_mVP);

    PS_INPUT_HAIR Output;

    Output.Position     = tressfxVert.Position;
    return Output;
}

[earlydepthstencil]
void HairShadowPS(PS_INPUT_HAIR input) : SV_Target
{
}